Index: code/branches/core6/src/modules/weapons/munitions/RocketMunition.h
===================================================================
--- code/branches/core6/src/modules/weapons/munitions/RocketMunition.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/munitions/RocketMunition.h	(revision 9629)
@@ -51,5 +51,5 @@
     {
         public:
-            RocketMunition(BaseObject* creator);
+            RocketMunition(Context* context);
             virtual ~RocketMunition() {}
     };
Index: code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/BasicProjectile.cc	(revision 9629)
@@ -106,5 +106,5 @@
                 {
                     {
-                        ParticleSpawner* effect = new ParticleSpawner(this->getShooter()->getCreator());
+                        ParticleSpawner* effect = new ParticleSpawner(this->getShooter()->getContext());
                         effect->setPosition(entity->getPosition());
                         effect->setOrientation(entity->getOrientation());
@@ -115,5 +115,5 @@
                     // Second effect with same condition
                     {
-                        ParticleSpawner* effect = new ParticleSpawner(this->getShooter()->getCreator());
+                        ParticleSpawner* effect = new ParticleSpawner(this->getShooter()->getContext());
                         effect->setPosition(entity->getPosition());
                         effect->setOrientation(entity->getOrientation());
@@ -127,5 +127,5 @@
                 if (victim && victim->hasShield() && (this->getDamage() > 0.0f || this->getShieldDamage() > 0.0f) && victim->getHealth() > 0.0f)
                 {
-                    ParticleSpawner* effect = new ParticleSpawner(this->getShooter()->getCreator());
+                    ParticleSpawner* effect = new ParticleSpawner(this->getShooter()->getContext());
                     effect->setDestroyAfterLife(true);
                     effect->setSource("Orxonox/Shield");
Index: code/branches/core6/src/modules/weapons/projectiles/BillboardProjectile.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 9629)
@@ -42,5 +42,5 @@
     CreateFactory(BillboardProjectile);
 
-    BillboardProjectile::BillboardProjectile(BaseObject* creator) : Projectile(creator)
+    BillboardProjectile::BillboardProjectile(Context* context) : Projectile(context)
     {
         RegisterObject(BillboardProjectile);
Index: code/branches/core6/src/modules/weapons/projectiles/BillboardProjectile.h
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 9629)
@@ -55,5 +55,5 @@
     {
         public:
-            BillboardProjectile(BaseObject* creator);
+            BillboardProjectile(Context* context);
             virtual ~BillboardProjectile();
 
Index: code/branches/core6/src/modules/weapons/projectiles/LightningGunProjectile.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 9629)
@@ -42,5 +42,5 @@
     CreateFactory(LightningGunProjectile);
 
-    LightningGunProjectile::LightningGunProjectile(BaseObject* creator) : BillboardProjectile(creator)
+    LightningGunProjectile::LightningGunProjectile(Context* context) : BillboardProjectile(context)
     {
         RegisterObject(LightningGunProjectile);
Index: code/branches/core6/src/modules/weapons/projectiles/LightningGunProjectile.h
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/LightningGunProjectile.h	(revision 9629)
@@ -55,5 +55,5 @@
     {
         public:
-            LightningGunProjectile(BaseObject* creator);
+            LightningGunProjectile(Context* context);
             virtual ~LightningGunProjectile() {}
 
Index: code/branches/core6/src/modules/weapons/projectiles/ParticleProjectile.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/ParticleProjectile.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/ParticleProjectile.cc	(revision 9629)
@@ -43,5 +43,5 @@
     CreateFactory(ParticleProjectile);
 
-    ParticleProjectile::ParticleProjectile(BaseObject* creator) : BillboardProjectile(creator)
+    ParticleProjectile::ParticleProjectile(Context* context) : BillboardProjectile(context)
     {
         RegisterObject(ParticleProjectile);
Index: code/branches/core6/src/modules/weapons/projectiles/ParticleProjectile.h
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/ParticleProjectile.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/ParticleProjectile.h	(revision 9629)
@@ -51,5 +51,5 @@
     {
         public:
-            ParticleProjectile(BaseObject* creator);
+            ParticleProjectile(Context* context);
             virtual ~ParticleProjectile();
             virtual void changedVisibility();
Index: code/branches/core6/src/modules/weapons/projectiles/Projectile.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/Projectile.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/Projectile.cc	(revision 9629)
@@ -46,5 +46,5 @@
     CreateFactory(Projectile);
 
-    Projectile::Projectile(BaseObject* creator) : MovableEntity(creator), BasicProjectile()
+    Projectile::Projectile(Context* context) : MovableEntity(context), BasicProjectile()
     {
         RegisterObject(Projectile);
@@ -60,5 +60,5 @@
             this->setCollisionType(Kinematic);
 
-            SphereCollisionShape* shape = new SphereCollisionShape(this);
+            SphereCollisionShape* shape = new SphereCollisionShape(this->getContext());
             shape->setRadius(20.0f);
             this->attachCollisionShape(shape);
Index: code/branches/core6/src/modules/weapons/projectiles/Projectile.h
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/Projectile.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/Projectile.h	(revision 9629)
@@ -58,5 +58,5 @@
     {
         public:
-            Projectile(BaseObject* creator);
+            Projectile(Context* context);
             virtual ~Projectile();
 
Index: code/branches/core6/src/modules/weapons/projectiles/Rocket.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/Rocket.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/Rocket.cc	(revision 9629)
@@ -57,8 +57,8 @@
         Constructor. Registers the object and initializes some default values.
     */
-    Rocket::Rocket(BaseObject* creator)
-        : ControllableEntity(creator)
+    Rocket::Rocket(Context* context)
+        : ControllableEntity(context)
         , BasicProjectile()
-        , RadarViewable(creator, static_cast<WorldEntity*>(this))
+        , RadarViewable(this, static_cast<WorldEntity*>(this))
     {
         RegisterObject(Rocket);// Register the Rocket class to the core
@@ -73,5 +73,5 @@
 
             // Create rocket model
-            Model* model = new Model(this);
+            Model* model = new Model(this->getContext());
             model->setMeshSource("rocket.mesh");
             model->scale(0.7f);
@@ -79,5 +79,5 @@
 
             // Add effects.
-            ParticleEmitter* fire = new ParticleEmitter(this);
+            ParticleEmitter* fire = new ParticleEmitter(this->getContext());
             this->attach(fire);
             fire->setOrientation(this->getOrientation());
@@ -89,5 +89,5 @@
 
             // Add collision shape
-            ConeCollisionShape* collisionShape = new ConeCollisionShape(this);
+            ConeCollisionShape* collisionShape = new ConeCollisionShape(this->getContext());
             collisionShape->setRadius(3);
             collisionShape->setHeight(500);
@@ -97,5 +97,5 @@
 
             // Add sound
-            this->defSndWpnEngine_ = new WorldSound(this);
+            this->defSndWpnEngine_ = new WorldSound(this->getContext());
             this->defSndWpnEngine_->setLooping(true);
             this->defSndWpnEngine_->setSource("sounds/Rocket_engine.ogg");
@@ -103,5 +103,5 @@
             this->attach(defSndWpnEngine_);
 
-            this->defSndWpnLaunch_ = new WorldSound(this);
+            this->defSndWpnLaunch_ = new WorldSound(this->getContext());
             this->defSndWpnLaunch_->setLooping(false);
             this->defSndWpnLaunch_->setSource("sounds/Rocket_launch.ogg");
@@ -116,5 +116,5 @@
 
         // Add camera
-        CameraPosition* camPosition = new CameraPosition(this);
+        CameraPosition* camPosition = new CameraPosition(this->getContext());
         camPosition->setPosition(0,4,15);
         camPosition->setAllowMouseLook(true);
@@ -226,11 +226,11 @@
         if(this->getShooter())
         {
-            effect1 = new ParticleSpawner(this->getShooter()->getCreator());
-            effect2 = new ParticleSpawner(this->getShooter()->getCreator());
+            effect1 = new ParticleSpawner(this->getShooter()->getContext());
+            effect2 = new ParticleSpawner(this->getShooter()->getContext());
         }
         else
         {
-            effect1 = new ParticleSpawner(static_cast<BaseObject*>(this->getScene().get()));
-            effect2 = new ParticleSpawner(static_cast<BaseObject*>(this->getScene().get()));
+            effect1 = new ParticleSpawner(this->getContext());
+            effect2 = new ParticleSpawner(this->getContext());
         }
 
Index: code/branches/core6/src/modules/weapons/projectiles/Rocket.h
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/Rocket.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/Rocket.h	(revision 9629)
@@ -59,5 +59,5 @@
     {
         public:
-            Rocket(BaseObject* creator);
+            Rocket(Context* context);
             virtual ~Rocket();
 
Index: code/branches/core6/src/modules/weapons/projectiles/SimpleRocket.cc
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 9629)
@@ -56,8 +56,8 @@
     const float SimpleRocket::FUEL_PERCENTAGE = 0.8f;
 
-    SimpleRocket::SimpleRocket(BaseObject* creator)
-        : ControllableEntity(creator)
+    SimpleRocket::SimpleRocket(Context* context)
+        : ControllableEntity(context)
         , BasicProjectile()
-        , RadarViewable(creator, static_cast<WorldEntity*>(this))
+        , RadarViewable(this, static_cast<WorldEntity*>(this))
     {
         RegisterObject(SimpleRocket);// Register the SimpleRocket class to the core
@@ -74,5 +74,5 @@
 
             // Create rocket model.
-            Model* model = new Model(this);
+            Model* model = new Model(this->getContext());
             model->setMeshSource("rocket.mesh");
             model->scale(0.7f);
@@ -80,5 +80,5 @@
 
             // Add effects.
-            this->fire_ = new ParticleEmitter(this);
+            this->fire_ = new ParticleEmitter(this->getContext());
             this->attach(this->fire_);
 
@@ -91,5 +91,5 @@
             // Add collision shape.
             // TODO: fix the orientation and size of this collision shape to match the rocket
-            ConeCollisionShape* collisionShape = new ConeCollisionShape(this);
+            ConeCollisionShape* collisionShape = new ConeCollisionShape(this->getContext());
             collisionShape->setOrientation(this->getOrientation());
             collisionShape->setRadius(1.5f);
Index: code/branches/core6/src/modules/weapons/projectiles/SimpleRocket.h
===================================================================
--- code/branches/core6/src/modules/weapons/projectiles/SimpleRocket.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/projectiles/SimpleRocket.h	(revision 9629)
@@ -60,5 +60,5 @@
     {
         public:
-            SimpleRocket(BaseObject* creator);
+            SimpleRocket(Context* context);
             virtual ~SimpleRocket();
             virtual void tick(float dt);
Index: code/branches/core6/src/modules/weapons/weaponmodes/EnergyDrink.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/EnergyDrink.cc	(revision 9629)
@@ -51,5 +51,5 @@
     CreateFactory(EnergyDrink);
 
-    EnergyDrink::EnergyDrink(BaseObject* creator) : WeaponMode(creator)
+    EnergyDrink::EnergyDrink(Context* context) : WeaponMode(context)
     {
         RegisterObject(EnergyDrink);
@@ -101,6 +101,6 @@
     {
         // Create the projectile
-        Projectile* projectile = new Projectile(this);
-        Model* model = new Model(projectile);
+        Projectile* projectile = new Projectile(this->getContext());
+        Model* model = new Model(projectile->getContext());
         model->setMeshSource("can.mesh");
         model->setCastShadows(false);
@@ -127,5 +127,5 @@
     void EnergyDrink::muzzleflash()
     {
-        MuzzleFlash *muzzleFlash = new MuzzleFlash(this);
+        MuzzleFlash *muzzleFlash = new MuzzleFlash(this->getContext());
         this->getWeapon()->attach(muzzleFlash);
         muzzleFlash->setPosition(this->getMuzzleOffset());
Index: code/branches/core6/src/modules/weapons/weaponmodes/EnergyDrink.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/EnergyDrink.h	(revision 9629)
@@ -54,5 +54,5 @@
     {
         public:
-            EnergyDrink(BaseObject* creator);
+            EnergyDrink(Context* context);
             virtual ~EnergyDrink() {}
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/FusionFire.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/FusionFire.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/FusionFire.cc	(revision 9629)
@@ -48,5 +48,5 @@
     CreateFactory(FusionFire);
 
-    FusionFire::FusionFire(BaseObject* creator) : WeaponMode(creator)
+    FusionFire::FusionFire(Context* context) : WeaponMode(context)
     {
         RegisterObject(FusionFire);
@@ -66,5 +66,5 @@
     void FusionFire::fire()
     {
-        BillboardProjectile* projectile = new BillboardProjectile(this);
+        BillboardProjectile* projectile = new BillboardProjectile(this->getContext());
 
         projectile->setOrientation(this->getMuzzleOrientation());
Index: code/branches/core6/src/modules/weapons/weaponmodes/FusionFire.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/FusionFire.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/FusionFire.h	(revision 9629)
@@ -51,5 +51,5 @@
     {
         public:
-            FusionFire(BaseObject* creator);
+            FusionFire(Context* context);
             virtual ~FusionFire() {}
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/HsW01.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/HsW01.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/HsW01.cc	(revision 9629)
@@ -52,5 +52,5 @@
     CreateFactory(HsW01);
 
-    HsW01::HsW01(BaseObject* creator) : WeaponMode(creator)
+    HsW01::HsW01(Context* context) : WeaponMode(context)
     {
         RegisterObject(HsW01);
@@ -111,6 +111,6 @@
 
         // Create the projectile.
-        Projectile* projectile = new Projectile(this);
-        Model* model = new Model(projectile);
+        Projectile* projectile = new Projectile(this->getContext());
+        Model* model = new Model(projectile->getContext());
         model->setMeshSource(mesh_);
         model->setCastShadows(false);
@@ -138,5 +138,5 @@
     void HsW01::muzzleflash()
     {
-        MuzzleFlash *muzzleFlash = new MuzzleFlash(this);
+        MuzzleFlash *muzzleFlash = new MuzzleFlash(this->getContext());
         this->getWeapon()->attach(muzzleFlash);
         muzzleFlash->setPosition(this->getMuzzleOffset());
Index: code/branches/core6/src/modules/weapons/weaponmodes/HsW01.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/HsW01.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/HsW01.h	(revision 9629)
@@ -53,5 +53,5 @@
     {
         public:
-            HsW01(BaseObject* creator);
+            HsW01(Context* context);
             virtual ~HsW01();
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/LaserFire.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/LaserFire.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/LaserFire.cc	(revision 9629)
@@ -47,5 +47,5 @@
     CreateFactory(LaserFire);
 
-    LaserFire::LaserFire(BaseObject* creator) : WeaponMode(creator)
+    LaserFire::LaserFire(Context* context) : WeaponMode(context)
     {
         RegisterObject(LaserFire);
@@ -64,5 +64,5 @@
     void LaserFire::fire()
     {
-        ParticleProjectile* projectile = new ParticleProjectile(this);
+        ParticleProjectile* projectile = new ParticleProjectile(this->getContext());
 
         projectile->setOrientation(this->getMuzzleOrientation());
Index: code/branches/core6/src/modules/weapons/weaponmodes/LaserFire.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/LaserFire.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/LaserFire.h	(revision 9629)
@@ -51,5 +51,5 @@
     {
         public:
-            LaserFire(BaseObject* creator);
+            LaserFire(Context* context);
             virtual ~LaserFire() {}
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/LightningGun.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/LightningGun.cc	(revision 9629)
@@ -46,5 +46,5 @@
     CreateFactory(LightningGun);
 
-    LightningGun::LightningGun(BaseObject* creator) : WeaponMode(creator)
+    LightningGun::LightningGun(Context* context) : WeaponMode(context)
     {
         RegisterObject(LightningGun);
@@ -68,5 +68,5 @@
     void LightningGun::fire()
     {
-        LightningGunProjectile* projectile = new LightningGunProjectile(this);
+        LightningGunProjectile* projectile = new LightningGunProjectile(this->getContext());
         projectile->setMaterial("Flares/LightningBall_");
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/LightningGun.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/LightningGun.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/LightningGun.h	(revision 9629)
@@ -51,5 +51,5 @@
     {
         public:
-            LightningGun(BaseObject* creator);
+            LightningGun(Context* context);
             virtual ~LightningGun();
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/RocketFire.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 9629)
@@ -48,5 +48,5 @@
     CreateFactory(RocketFire);
 
-    RocketFire::RocketFire(BaseObject* creator) : WeaponMode(creator)
+    RocketFire::RocketFire(Context* context) : WeaponMode(context)
     {
         RegisterObject(RocketFire);
@@ -71,5 +71,5 @@
     void RocketFire::fire()
     {
-        Rocket* rocket = new Rocket(this);
+        Rocket* rocket = new Rocket(this->getContext());
 
         this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
Index: code/branches/core6/src/modules/weapons/weaponmodes/RocketFire.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/RocketFire.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/RocketFire.h	(revision 9629)
@@ -51,5 +51,5 @@
     {
         public:
-            RocketFire(BaseObject* creator);
+            RocketFire(Context* context);
             virtual ~RocketFire();
 
Index: code/branches/core6/src/modules/weapons/weaponmodes/SimpleRocketFire.cc
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 9629)
@@ -52,5 +52,5 @@
     CreateFactory(SimpleRocketFire);
 
-    SimpleRocketFire::SimpleRocketFire(BaseObject* creator) : WeaponMode(creator)
+    SimpleRocketFire::SimpleRocketFire(Context* context) : WeaponMode(context)
     {
         RegisterObject(SimpleRocketFire);
@@ -76,5 +76,5 @@
     void SimpleRocketFire::fire()
     {
-        RocketController* controller = new RocketController(this);
+        RocketController* controller = new RocketController(this->getContext());
         SimpleRocket* rocket = controller->getRocket();
         this->computeMuzzleParameters(this->getWeapon()->getWeaponPack()->getWeaponSystem()->getPawn()->getAimPosition());
Index: code/branches/core6/src/modules/weapons/weaponmodes/SimpleRocketFire.h
===================================================================
--- code/branches/core6/src/modules/weapons/weaponmodes/SimpleRocketFire.h	(revision 9628)
+++ code/branches/core6/src/modules/weapons/weaponmodes/SimpleRocketFire.h	(revision 9629)
@@ -50,5 +50,5 @@
     {
         public:
-            SimpleRocketFire(BaseObject* creator);
+            SimpleRocketFire(Context* context);
             virtual ~SimpleRocketFire();
             void deactivateFire();
Index: code/branches/core6/src/orxonox/Level.cc
===================================================================
--- code/branches/core6/src/orxonox/Level.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/Level.cc	(revision 9629)
@@ -45,5 +45,5 @@
     CreateFactory(Level);
 
-    Level::Level(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    Level::Level(Context* context) : BaseObject(context), Synchronisable(context), Context(context)
     {
         RegisterObject(Level);
Index: code/branches/core6/src/orxonox/Level.h
===================================================================
--- code/branches/core6/src/orxonox/Level.h	(revision 9628)
+++ code/branches/core6/src/orxonox/Level.h	(revision 9629)
@@ -41,8 +41,8 @@
 namespace orxonox
 {
-    class _OrxonoxExport Level : public BaseObject, public Synchronisable
+    class _OrxonoxExport Level : public BaseObject, public Synchronisable, public Context
     {
         public:
-            Level(BaseObject* creator);
+            Level(Context* context);
             virtual ~Level();
 
Index: code/branches/core6/src/orxonox/LevelInfo.cc
===================================================================
--- code/branches/core6/src/orxonox/LevelInfo.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/LevelInfo.cc	(revision 9629)
@@ -250,5 +250,5 @@
         The creator of this object.
     */
-    LevelInfo::LevelInfo(BaseObject* creator) : BaseObject(creator)
+    LevelInfo::LevelInfo(Context* context) : BaseObject(context)
     {
         RegisterObject(LevelInfo);
Index: code/branches/core6/src/orxonox/LevelInfo.h
===================================================================
--- code/branches/core6/src/orxonox/LevelInfo.h	(revision 9628)
+++ code/branches/core6/src/orxonox/LevelInfo.h	(revision 9629)
@@ -204,5 +204,5 @@
     {
         public:
-            LevelInfo(BaseObject* creator);
+            LevelInfo(Context* context);
             virtual ~LevelInfo();
 
Index: code/branches/core6/src/orxonox/Scene.cc
===================================================================
--- code/branches/core6/src/orxonox/Scene.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/Scene.cc	(revision 9629)
@@ -53,5 +53,5 @@
     CreateFactory(Scene);
 
-    Scene::Scene(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    Scene::Scene(Context* context) : BaseObject(context), Synchronisable(context), Context(context)
     {
         RegisterObject(Scene);
Index: code/branches/core6/src/orxonox/Scene.h
===================================================================
--- code/branches/core6/src/orxonox/Scene.h	(revision 9628)
+++ code/branches/core6/src/orxonox/Scene.h	(revision 9629)
@@ -45,8 +45,8 @@
 namespace orxonox
 {
-    class _OrxonoxExport Scene : public BaseObject, public Synchronisable, public Tickable
+    class _OrxonoxExport Scene : public BaseObject, public Synchronisable, public Tickable, public Context
     {
         public:
-            Scene(BaseObject* creator);
+            Scene(Context* context);
             virtual ~Scene();
 
Index: code/branches/core6/src/orxonox/Test.cc
===================================================================
--- code/branches/core6/src/orxonox/Test.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/Test.cc	(revision 9629)
@@ -56,5 +56,5 @@
     Test* Test::instance_ = 0;
 
-    Test::Test(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    Test::Test(Context* context) : BaseObject(context), Synchronisable(context)
     {
         assert(instance_==0);
Index: code/branches/core6/src/orxonox/Test.h
===================================================================
--- code/branches/core6/src/orxonox/Test.h	(revision 9628)
+++ code/branches/core6/src/orxonox/Test.h	(revision 9629)
@@ -46,5 +46,5 @@
   {
     public:
-      Test(BaseObject* creator);
+      Test(Context* context);
       virtual ~Test();
 
Index: code/branches/core6/src/orxonox/chat/ChatHistory.cc
===================================================================
--- code/branches/core6/src/orxonox/chat/ChatHistory.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/chat/ChatHistory.cc	(revision 9629)
@@ -39,5 +39,4 @@
   /* constructor */
 #ifndef CHATTEST
-  //ChatHistory::ChatHistory( BaseObject* creator ) : BaseObject(creator)
   ChatHistory::ChatHistory()
 #else
Index: code/branches/core6/src/orxonox/collisionshapes/CollisionShape.cc
===================================================================
--- code/branches/core6/src/orxonox/collisionshapes/CollisionShape.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/collisionshapes/CollisionShape.cc	(revision 9629)
@@ -49,7 +49,7 @@
         Constructor. Registers and initializes the object.
     */
-    CollisionShape::CollisionShape(BaseObject* creator)
-        : BaseObject(creator)
-        , Synchronisable(creator)
+    CollisionShape::CollisionShape(Context* context)
+        : BaseObject(context)
+        , Synchronisable(context)
     {
         RegisterObject(CollisionShape);
Index: code/branches/core6/src/orxonox/collisionshapes/CollisionShape.h
===================================================================
--- code/branches/core6/src/orxonox/collisionshapes/CollisionShape.h	(revision 9628)
+++ code/branches/core6/src/orxonox/collisionshapes/CollisionShape.h	(revision 9629)
@@ -58,5 +58,5 @@
     {
         public:
-            CollisionShape(BaseObject* creator);
+            CollisionShape(Context* context);
             virtual ~CollisionShape();
 
Index: code/branches/core6/src/orxonox/collisionshapes/CompoundCollisionShape.cc
===================================================================
--- code/branches/core6/src/orxonox/collisionshapes/CompoundCollisionShape.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/collisionshapes/CompoundCollisionShape.cc	(revision 9629)
@@ -48,5 +48,5 @@
         Constructor. Registers and initializes the object.
     */
-    CompoundCollisionShape::CompoundCollisionShape(BaseObject* creator) : CollisionShape(creator)
+    CompoundCollisionShape::CompoundCollisionShape(Context* context) : CollisionShape(context)
     {
         RegisterObject(CompoundCollisionShape);
Index: code/branches/core6/src/orxonox/collisionshapes/CompoundCollisionShape.h
===================================================================
--- code/branches/core6/src/orxonox/collisionshapes/CompoundCollisionShape.h	(revision 9628)
+++ code/branches/core6/src/orxonox/collisionshapes/CompoundCollisionShape.h	(revision 9629)
@@ -58,5 +58,5 @@
     {
         public:
-            CompoundCollisionShape(BaseObject* creator);
+            CompoundCollisionShape(Context* context);
             virtual ~CompoundCollisionShape();
 
Index: code/branches/core6/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc
===================================================================
--- code/branches/core6/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc	(revision 9629)
@@ -37,5 +37,5 @@
 namespace orxonox
 {
-    WorldEntityCollisionShape::WorldEntityCollisionShape(BaseObject* creator) : CompoundCollisionShape(creator)
+    WorldEntityCollisionShape::WorldEntityCollisionShape(Context* context) : CompoundCollisionShape(context)
     {
         RegisterObject(WorldEntityCollisionShape);
Index: code/branches/core6/src/orxonox/collisionshapes/WorldEntityCollisionShape.h
===================================================================
--- code/branches/core6/src/orxonox/collisionshapes/WorldEntityCollisionShape.h	(revision 9628)
+++ code/branches/core6/src/orxonox/collisionshapes/WorldEntityCollisionShape.h	(revision 9629)
@@ -38,5 +38,5 @@
     {
         public:
-            WorldEntityCollisionShape(BaseObject* creator);
+            WorldEntityCollisionShape(Context* context);
             virtual ~WorldEntityCollisionShape();
 
Index: code/branches/core6/src/orxonox/controllers/AIController.cc
===================================================================
--- code/branches/core6/src/orxonox/controllers/AIController.cc	(revision 9628)
+++ code/branches/core6/src/orxonox/controllers/AIController.cc	(revision 9629)
@@ -41,5 +41,5 @@
     CreateFactory(AIController);
 
-    AIController::AIController(BaseObject* creator) : ArtificialController(creator)
+    AIController::AIController(Context* context) : ArtificialController(context)
     {
         RegisterObject(AIController);
